import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.util.zip.*;

public class ZipTest extends FrameFecha implements ActionListener {
 
  private List fileList = new List();
  // private TextArea fileText = new TextArea();
  private TextArea fileText = new TextArea(10,150);
  private String lastDir = "";
  private String zipname;
   
  public ZipTest() {
     Label labelMenuList = new Label("Lista de arquivos: selecione um");
     Label labelArqDescompactado = new Label("Arquivo descompactado");
     Panel pSup = new Panel();
     Panel pInf = new Panel();
     
     MenuBar mbar = new MenuBar();
     Menu m = new Menu("Arquivo");
     MenuItem m1 = new MenuItem("Abrir");
     m1.addActionListener(this);
     m.add(m1);            
     MenuItem m2 = new MenuItem("Finalizar");
     m2.addActionListener(this);
     m.add(m2);            
     mbar.add(m);
     setMenuBar(mbar);
     fileList.addActionListener(this);
          
     //add(fileList, "North");
     //add(fileText, "Center");
     pSup.setSize( this.getSize().width, 40);
     // pInf.setSize( this.getSize().width/10, 200); 
     // pInf.setSize( 10, 200); 
     // Dimension dim = pInf.getSize();
     // System.out.println(dim.getSize().width+" "+dim.getSize().height);

     // fileText.setColumns(4);
     // fileText.preferredSize(10,20);
     // Dimension dim = fileText.getPreferredSize();
     // System.out.println(dim.getSize().width+" "+dim.getSize().height);

     setLayout (new BorderLayout());
     pSup.setLayout (new BorderLayout());
     pInf.setLayout (new BorderLayout());
     
     pSup.add(labelMenuList, "North");
     pSup.add(fileList, "South"); //"Center");
     pInf.add(labelArqDescompactado, "North");
     pInf.add(fileText, "South"); //"Center");
     add(pSup, "North");
     add(pInf, "South"); //"Center");
     }

   public void actionPerformed(ActionEvent evt) {
     String arg = evt.getActionCommand();
     if (evt.getSource() == fileList) {
	loadZipFile(arg);
        }
     else 
     if (arg.equals("Abrir")) {
	FileDialog d = new FileDialog(this, "Abrir arquivo Zip", FileDialog.LOAD);
        d.setFile("*.zip");
        d.setDirectory(lastDir);
        d.show();
        String f = d.getFile();
        lastDir = d.getDirectory();
        if (f != null) {
	   zipname = lastDir + f;
           scanZipFile();            
           }
        }
     else if(arg.equals("Finalizar")) System.exit(0);
     }   

   public void scanZipFile() {
     fileList.removeAll();
     try {
       ZipInputStream zin = new ZipInputStream(new FileInputStream(zipname));
       ZipEntry entry;
       while ((entry = zin.getNextEntry()) != null) {
	 fileList.add(entry.getName());
         zin.closeEntry();
         }
       zin.close();
       }
     catch(IOException e) {}
     }

   // L formato Zip, descompactando
   public void loadZipFile(String name) {
     try {
       ZipInputStream zin = new ZipInputStream(new FileInputStream(zipname));
       ZipEntry entry;
       fileText.setText("");
       while ((entry = zin.getNextEntry()) != null) {
	 if (entry.getName().equals(name)) {
	    BufferedReader in = new BufferedReader(new InputStreamReader(zin));
            String s;
            while ((s = in.readLine()) != null) 
              fileText.append(s + "\n");
            }
         zin.closeEntry();
         }
       zin.close();
       }
     catch(IOException e) {}
     }

   public static void main(String args[]) {
     Frame f = new ZipTest();
     f.show();
     }
}
